import math 
from tkinter import *
from tkinter import messagebox


# Globals
WIDTH = 1200
HEIGHT = 800
VECTOR=0
X1=WIDTH/2-200
Y1=HEIGHT/2
LENGHT=4

axiom = "FFFF"
rules = {"F":"F++F++"}

iterations =7 # TOP: 16
angle = 120


def create_l_system(iters, axiom, rules):
    start_string = axiom
    if iters == 0:
        return axiom
    end_string = ""
    for _ in range(iters):
        end_string = "".join(rules[i] if i in rules else i for i in start_string)
        start_string = end_string

    return end_string


def draw_l_system(canv1, instructions, angle):
    global X1
    global Y1
    global VECTOR
    for cmd in instructions:
        if cmd == 'F':
            X2=X1+LENGHT*math.sin (VECTOR*math.pi/180)  
            Y2=Y1+LENGHT*math.cos (VECTOR*math.pi/180)  
            canv1.create_line(X1, Y1, X2, Y2)
            X1=X2
            Y1=Y2
        elif cmd == 'f':
            X2=X1+LENGHT*math.sin (VECTOR*math.pi/180)  
            Y2=Y1+LENGHT*math.cos (VECTOR*math.pi/180)  
            X1=X2
            Y1=Y2
        elif cmd == '+':
            VECTOR=VECTOR+angle
        elif cmd == '-':
            VECTOR=VECTOR-angle

    
def DelCanvas():
    global c
    messagebox.showinfo("delete")
    c.delete("all")
    
def CreCanvas():
    c = Canvas(root, width=WIDTH, height=HEIGHT, bg="#FFFFFF")
    c.pack(side = 'bottom')

    inst = create_l_system(iterations, axiom, rules)
    draw_l_system(c, inst, angle)
    

root = Tk()
root.title("Fractal TK sim")

panelFrame = Frame(root, height = 60, bg = 'gray')

btn = Button(panelFrame, text="Create",command=CreCanvas) #цвет фона и надписи
btn2 = Button(panelFrame, text="Delete",command=DelCanvas) #цвет фона и надписи

panelFrame.pack(side = 'top', fill = 'x')
btn.pack(side = 'left')
btn2.pack(side = 'left')



root.mainloop()
